// Universal interface to NM

#ifndef __MC7601_LL_HOST__H__
#define __MC7601_LL_HOST__H__

#ifdef _WIN32
//----------------------------------------------------------------------------//
// Windows                                                                    //
//----------------------------------------------------------------------------//
#include "interface_PC-ARM.h"

#define WR_Word SP_Word
#define WR_Addr SP_Addr
#define WR_Board SP_Board
#define WR_Access SP_Access

#define WR_OK SP_OK
#define WR_ERROR SP_FAIL
#define WR_CANCEL SP_CANCEL
#define WR_AGAIN SP_AGAIN
#define WR_TIMEOUT SP_TIMEOUT
#define WR_FILE SP_FILE
#define WR_BADADDRESS SP_BADADDRESS
#define WR_PC_DMN_ERROR SP_PC_DMN_FAIL
#define WR_CONNECTION SP_CONNECTION
#define WR_CHANNEL_TIMEOUT SP_CHANNEL_TIMEOUT
#define WR_CHANNEL_ERROR SP_CHANNEL_FAIL
#define WR_ARM_DMN_ERROR SP_ARM_DMN_FAIL
#define WR_ARM_DMN_AGAIN SP_ARM_DMN_AGAIN
#define WR_NOT_SUPPORTED SP_NOT_SUPPORTED

#define WR_channel_conf SP_channel_conf

#define WR_SetChannel(conf, chan, p1, p2)\
conf.channel = chan;\
conf.param1 = p1;\
conf.param2 = p2;

#define WR_GetBoardDesc(channel_conf, board) SP_GetBoardDesc(channel_conf, board)
#define WR_CloseBoardDesc(board) SP_CloseBoardDesc(board)
#define WR_GetVersion(board, version_major, version_minor) SP_GetVersion(board, version_major, version_minor)
#define WR_GetCoreCount(board, count) SP_NOT_SUPPORTED
#define WR_GetAccess(board, coreNo, access) SP_GetAccess(board, coreNo, access)
#define WR_CloseAccess(access) SP_CloseAccess(access)
#define WR_ResetCore(access) SP_ResetCore(access)
#define WR_LoadInitCode(access) SP_LoadInitCode(access)
#define WR_LoadProgram(access, addrProgram, sizeProgram, timeOut) SP_LoadProgram(access, addrProgram, sizeProgram, timeOut)
#define WR_LoadProgramFile(access, filename, timeOut) SP_LoadProgramFile(access, filename, timeOut)
#define WR_WaitEndProgram(access, returnValue, timeOut) SP_WaitEndProgram(access, returnValue, timeOut)
#define WR_ReadMemBlock(access, block, address, len) SP_ReadMemBlock(access, block, address, len)
#define WR_WriteMemBlock(access, block, address, len) SP_WriteMemBlock(access, block, address, len)
#define WR_ReadMemBlockSafe(access, block, address, len) SP_NOT_SUPPORTED
#define WR_WriteMemBlockSafe(access, block, address, len) SP_NOT_SUPPORTED
#define WR_Sync(access, timeOut, value, returnValue) SP_Sync(access, timeOut, value, returnValue)
#define WR_SyncArray(access, timeOut, value, outAddress, outLen, returnValue, inAddress, inLen) SP_SyncArray(access, timeOut, value, outAddress, outLen, returnValue, inAddress, inLen)
#define WR_InterruptNMI(access) SP_InterruptNMI(access)
#define WR_InterruptHPINT(access) SP_InterruptHPINT(access)
#define WR_InterruptLPINT(access) SP_InterruptLPINT(access)
#define WR_MaskInterruptHPINT(access, mask) SP_NOT_SUPPORTED
#define WR_MaskInterruptLPINT(access, mask) SP_NOT_SUPPORTED
#define WR_WaitInterruptHPINT(access, timeOut) SP_NOT_SUPPORTED
#define WR_WaitInterruptLPINT(access, timeOut) SP_NOT_SUPPORTED
#define WR_CancelWaitInterruptHPINT(access) SP_NOT_SUPPORTED
#define WR_CancelWaitInterruptLPINT(access) SP_NOT_SUPPORTED
#define WR_SetChannelTimeout(board, timeOut) SP_SetChannelTimeout(board, timeOut)
#define WR_GetChannelInf(board, chan, p1, p2, timeOut) SP_GetChannelInf(board, chan, p1, p2, timeOut)

//------------------------------------------------------------------------------
#else // _WIN32
//----------------------------------------------------------------------------//
// Linux                                                                      //
//----------------------------------------------------------------------------//
#include "interface_libarm2neuro.h"

#define WR_Word PL_Word
#define WR_Addr PL_Addr
#define WR_Board void
#define WR_Access PL_Access

#define WR_OK PL_OK
#define WR_ERROR PL_ERROR
#define WR_CANCEL PL_CANCEL
#define WR_AGAIN PL_AGAIN
#define WR_TIMEOUT PL_TIMEOUT
#define WR_FILE PL_FILE
#define WR_BADADDRESS PL_BADADDRESS
#define WR_PC_DMN_ERROR PL_ERROR
#define WR_CONNECTION PL_ERROR
#define WR_CHANNEL_TIMEOUT PL_ERROR
#define WR_CHANNEL_ERROR PL_ERROR
#define WR_ARM_DMN_ERROR PL_DMN_ERROR
#define WR_ARM_DMN_AGAIN PL_DMN_AGAIN
#define WR_NOT_SUPPORTED PL_NOT_SUPPORTED

#define WR_channel_conf void*

#define ANMETHERNET 0

#define WR_SetChannel(conf, chan, p1, p2)

#define WR_GetBoardDesc(channel_conf, board) PL_OK
#define WR_CloseBoardDesc(board) PL_OK
#define WR_GetVersion(board, version_major, version_minor) PL_GetVersion(version_major, version_minor)
#define WR_GetCoreCount(board, count) PL_GetCoreCount(count)
#define WR_GetAccess(board, coreNo, access) PL_GetAccess(coreNo, access)
#define WR_CloseAccess(access) PL_CloseAccess(access)
#define WR_ResetCore(access) PL_ResetCore(access)
#define WR_LoadInitCode(access) PL_LoadInitCode(access)
#define WR_LoadProgram(access, addrProgram, sizeProgram, timeOut) PL_LoadProgram(access, addrProgram, timeOut)
#define WR_LoadProgramFile(access, filename, timeOut) PL_LoadProgramFile(access, filename, timeOut)
#define WR_WaitEndProgram(access, returnValue, timeOut) PL_WaitEndProgram(access, returnValue, timeOut)
#define WR_ReadMemBlock(access, block, address, len) PL_ReadMemBlock(access, block, address, len)
#define WR_WriteMemBlock(access, block, address, len) PL_WriteMemBlock(access, block, address, len)
#define WR_ReadMemBlockSafe(access, block, address, len) PL_ReadMemBlockSafe(access, block, address, len)
#define WR_WriteMemBlockSafe(access, block, address, len) PL_WriteMemBlockSafe(access, block, address, len)
#define WR_Sync(access, timeOut, value, returnValue) PL_Sync(access, timeOut, value, returnValue)
#define WR_SyncArray(access, timeOut, value, outAddress, outLen, returnValue, inAddress, inLen) PL_SyncArray(access, timeOut, value, outAddress, outLen, returnValue, inAddress, inLen)
#define WR_InterruptNMI(access) PL_InterruptNMI(access)
#define WR_InterruptHPINT(access) PL_InterruptHPINT(access)
#define WR_InterruptLPINT(access) PL_InterruptLPINT(access)
#define WR_MaskInterruptHPINT(access, mask) PL_MaskInterruptHPINT(access, mask)
#define WR_MaskInterruptLPINT(access, mask) PL_MaskInterruptLPINT(access, mask)
#define WR_WaitInterruptHPINT(access, timeOut) PL_WaitInterruptHPINT(access, timeOut)
#define WR_WaitInterruptLPINT(access, timeOut) PL_WaitInterruptLPINT(access, timeOut)
#define WR_CancelWaitInterruptHPINT(access) PL_CancelWaitInterruptHPINT(access)
#define WR_CancelWaitInterruptLPINT(access) PL_CancelWaitInterruptLPINT(access)
#define WR_SetChannelTimeout(board, timeOut) PL_OK
#define WR_GetChannelInf(board, chan, p1, p2, timeOut) PL_OK

//------------------------------------------------------------------------------
#endif // _WIN32

#endif // __MC7601_LL_HOST__H__
